<?php

/**
 * Course fulfillment class for quizzes.
 */
class CourseObjectQuizFulfillment extends CourseObjectNodeFulfillment {

  /**
   * Define storage for quiz result IDs.
   */
  function optionsDefinition() {
    return array('quiz_result_ids' => array());
  }

  /**
   * Remove all quiz attempts associated with this fulfillment.
   */
  function delete() {
    parent::delete();
    $result_ids = (array) $this->getOption('quiz_result_ids');
    if (course_quiz_quiz_version() >= 5) {
      entity_delete_multiple('quiz_result', $result_ids);
    }
    else {
      quiz_delete_results($result_ids);
    }
  }

}